diff --git a/game/client/src/main/java/net/minecraft/client/render/font/FontRendererDefault.java b/game/client/src/main/java/net/minecraft/client/render/font/FontRendererDefault.java
index 4f7efce80..02809c47e 100644
--- a/game/client/src/main/java/net/minecraft/client/render/font/FontRendererDefault.java
+++ b/game/client/src/main/java/net/minecraft/client/render/font/FontRendererDefault.java
@@ -2,7 +2,6 @@ package net.minecraft.client.render.font;
 
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.render.tessellator.Tessellator;
-import net.minecraft.client.render.texturepack.TexturePackList;
 import net.minecraft.client.util.helper.Colors;
 import net.minecraft.core.net.command.TextFormatting;
 import net.minecraft.core.util.helper.ChatAllowedCharacters;
@@ -15,9 +14,9 @@ import java.util.ArrayList;
 import java.util.List;
 import java.util.Random;
 
-public class FontRendererDefault implements FontRenderer {
+public class FontRendererDefault extends FontRenderer {
     public final @NotNull Font fallbackFont;
-    public final @NotNull Font font;
+    public final @Nullable Font font;
 
     protected final long @NotNull [] configStack = new long[32];
     protected byte stackIndex = 0;
@@ -31,15 +30,20 @@ public class FontRendererDefault implements FontRenderer {
     protected final double[] localYPosBuffer = new double[1];
     protected final long[] localConfigBuffer = new long[1];
 
-    public FontRendererDefault(@NotNull final Font font) {
-        this.fallbackFont = new FontUnicode(Minecraft.getMinecraft().textureManager);
+    public FontRendererDefault() {
+        this(null);
+    }
+
+    public FontRendererDefault(@Nullable final Font font) {
+        super();
+        this.fallbackFont = Fonts.UNICODE;
         this.font = font;
         this.random = new Random();
     }
 
-    protected void renderStringInternal(@NotNull final Tessellator tessellator, final @NotNull CharSequence chars, final double x, final double y, final double z, final boolean shadow, final long baseConfig, final double @Nullable [] xPosBuffer, final double @Nullable [] yPosBuffer, final long @Nullable [] configBuffer) {
+    private static final StringBuilder renderStringInternal_colorValue = new StringBuilder();
+    protected void renderStringInternal(@NotNull final Font font, @NotNull final Tessellator tessellator, final @NotNull CharSequence chars, final double x, final double y, final double z, final boolean shadow, final long baseConfig, final double @Nullable [] xPosBuffer, final double @Nullable [] yPosBuffer, final long @Nullable [] configBuffer) {
         double currX = x;
-        final double currY = y;
 
         this.random.setSeed(System.currentTimeMillis()/50);
 
@@ -50,22 +54,21 @@ public class FontRendererDefault implements FontRenderer {
                 final char cNext = chars.charAt(i + 1);
                 if (cNext == '<') {
                     int offAmount = 1;
-                    int j = i + 2; // First char after <
-                    final StringBuilder colorValue = new StringBuilder();
+                    renderStringInternal_colorValue.setLength(0);
                     boolean ended = false;
-                    while (j < chars.length()) {
+                    for (int j = 0; j < 8; j++) { // Maximum of 8 chars allowed in argb color code
                         offAmount++;
-                        if (chars.charAt(j) == '>'){
+                        final char pChar = chars.charAt(i + 2 + j);
+                        if (pChar == '>'){
                             ended = true;
                             break;
                         }
-                        colorValue.append(chars.charAt(j));
-                        j++;
+                        renderStringInternal_colorValue.append(pChar);
                     }
 
                     if (ended){
                         long colorInt = 0xFFFFFF;
-                        try { colorInt = decodeHexToLong(colorValue); } catch (final NumberFormatException ignored){}
+                        try { colorInt = decodeHexToLong(renderStringInternal_colorValue); } catch (final NumberFormatException ignored){}
 
                         this.currentConfig = SF.setColor(this.currentConfig, (colorInt & 0xFF_00_00_00L) == 0 ? (int) (colorInt & 0x00_FF_FF_FFL) | (SF.getColor(baseConfig) & 0xFF_00_00_00) : ((int)colorInt));
                         //noinspection AssignmentToForLoopParameter
@@ -128,82 +131,87 @@ public class FontRendererDefault implements FontRenderer {
                     }
                 }
             }
+            final Font charFont = font.canRenderChar(c) ? font : this.fallbackFont;
 
-            final int tex = textureForChar(c);
+            final int tex = charFont.textureForChar(c);
             if (this.currentTex != tex) {
                 this.currentTex = tex;
                 GL11.glBindTexture(GL11.GL_TEXTURE_2D, tex);
             }
 
-            currX += renderCharInternal(tessellator, c, currX, currY, z, SF.getColor(this.currentConfig), shadow);
+            currX += renderCharInternal(charFont, tessellator, c, currX, y, z, SF.getColor(this.currentConfig), shadow);
         }
 
         if (xPosBuffer != null) {
             xPosBuffer[0] = currX;
         }
         if (yPosBuffer != null) {
-            yPosBuffer[0] = currY + fontHeight() + 1;
+            yPosBuffer[0] = y + font.fontHeight() + 1;
         }
         if (configBuffer != null) {
             configBuffer[0] = this.currentConfig;
         }
     }
 
-    protected double renderCharInternal(@NotNull final Tessellator tessellator, final char c, final double x, final double y, final double z, final int color, final boolean shadow) {
+    protected double renderCharInternal(@NotNull final Font font, @NotNull final Tessellator tessellator, final char c, final double x, final double y, final double z, final int color, final boolean shadow) {
         final int rgb = color & 0xFFFFFF;
         final int shadowRGB = (color & 0xFCFCFC) >> 2; // Divide RGB by 4
         final int a = (color & 0xFF_00_00_00) != 0 ? (color >> 24) & 0xFF : 0xFF;
         tessellator.startDrawingQuads();
+
+        final double px = 1;
+        final double px2 = px * 2;
+
         double shift;
         final int fontIndex = ChatAllowedCharacters.ALLOWED_CHARACTERS.indexOf(c);
         if (SF.isObfuscated(this.currentConfig) && c != ' ' && fontIndex > 0) {
-            shift = charWidth(c);
-            final char randomChar = getObfuscatedChar(c, this.random);
+            shift = font.charWidth(c);
+            final char randomChar = font.getObfuscatedChar(c, this.random);
 
             if (shadow) {
                 tessellator.setColorRGBA_I(shadowRGB, a);
-                renderChar(tessellator, randomChar, x + 1, y + 1, z, SF.isItalic(this.currentConfig));
-                if (SF.isBold(this.currentConfig)) renderChar(tessellator, randomChar, x + 2, y + 1, z, SF.isItalic(this.currentConfig));
+                font.renderChar(tessellator, randomChar, x + px, y + px, z, SF.isItalic(this.currentConfig));
+                if (SF.isBold(this.currentConfig)) font.renderChar(tessellator, randomChar, x + px2, y + px, z, SF.isItalic(this.currentConfig));
             }
 
             tessellator.setColorRGBA_I(rgb, a);
-            renderChar(tessellator, randomChar, x, y, z, SF.isItalic(this.currentConfig));
+            font.renderChar(tessellator, randomChar, x, y, z, SF.isItalic(this.currentConfig));
             if (SF.isBold(this.currentConfig)) {
-                renderChar(tessellator, randomChar, x + 1, y, z, SF.isItalic(this.currentConfig));
-                shift++;
+                font.renderChar(tessellator, randomChar, x + px, y, z, SF.isItalic(this.currentConfig));
+                shift += px;
             }
 
         } else {
             if (shadow) {
                 tessellator.setColorRGBA_I(shadowRGB, a);
-                renderChar(tessellator, c, x + 1, y + 1, z, SF.isItalic(this.currentConfig));
-                if (SF.isBold(this.currentConfig)) renderChar(tessellator, c, x + 2, y + 1, z, SF.isItalic(this.currentConfig));
+                font.renderChar(tessellator, c, x + px, y + px, z, SF.isItalic(this.currentConfig));
+                if (SF.isBold(this.currentConfig)) font.renderChar(tessellator, c, x + px2, y + px, z, SF.isItalic(this.currentConfig));
             }
 
             tessellator.setColorRGBA_I(rgb, a);
-            shift = renderChar(tessellator, c, x, y, z, SF.isItalic(this.currentConfig));
+            shift = font.renderChar(tessellator, c, x, y, z, SF.isItalic(this.currentConfig));
             if (SF.isBold(this.currentConfig)) {
-                renderChar(tessellator, c, x + 1, y, z, SF.isItalic(this.currentConfig));
-                shift++;
+                font.renderChar(tessellator, c, x + px, y, z, SF.isItalic(this.currentConfig));
+                shift += px;
             }
         }
         tessellator.draw();
-
+        final int fontHeight = font.fontHeight();
         if (SF.isStrikethrough(this.currentConfig)) {
             GL11.glDisable(GL11.GL_TEXTURE_2D);
             tessellator.startDrawingQuads();
             if (shadow) {
                 tessellator.setColorRGBA_I(shadowRGB, a);
-                tessellator.addVertex(x + 1,        y + 1 + fontHeight() / 2d,       0.0D);
-                tessellator.addVertex(x + 1 + shift,y + 1 + fontHeight() / 2d,       0.0D);
-                tessellator.addVertex(x + 1 + shift,y + 1 + fontHeight() / 2d - 1.0F,0.0D);
-                tessellator.addVertex(x + 1,        y + 1 + fontHeight() / 2d - 1.0F,0.0D);
+                tessellator.addVertex(x + px,        y + px + fontHeight / 2d,     0.0D);
+                tessellator.addVertex(x + px + shift,y + px + fontHeight / 2d,     0.0D);
+                tessellator.addVertex(x + px + shift,y + px + fontHeight / 2d - px,0.0D);
+                tessellator.addVertex(x + px,        y + px + fontHeight / 2d - px,0.0D);
             }
             tessellator.setColorRGBA_I(rgb, a);
-            tessellator.addVertex(x,        y + fontHeight() / 2d,       0.0D);
-            tessellator.addVertex(x + shift,y + fontHeight() / 2d,       0.0D);
-            tessellator.addVertex(x + shift,y + fontHeight() / 2d - 1.0F,0.0D);
-            tessellator.addVertex(x,        y + fontHeight() / 2d - 1.0F,0.0D);
+            tessellator.addVertex(x,        y + fontHeight / 2d,     0.0D);
+            tessellator.addVertex(x + shift,y + fontHeight / 2d,     0.0D);
+            tessellator.addVertex(x + shift,y + fontHeight / 2d - px,0.0D);
+            tessellator.addVertex(x,        y + fontHeight / 2d - px,0.0D);
             tessellator.draw();
             GL11.glEnable(GL11.GL_TEXTURE_2D);
         }
@@ -213,46 +221,46 @@ public class FontRendererDefault implements FontRenderer {
             tessellator.startDrawingQuads();
             if (shadow) {
                 tessellator.setColorRGBA_I(shadowRGB, a);
-                tessellator.addVertex(x,            y + 2 + fontHeight(),        0.0D);
-                tessellator.addVertex(x + 1 + shift,y + 2 + fontHeight(),        0.0D);
-                tessellator.addVertex(x + 1 + shift,y + 2 + fontHeight() - 1.0F, 0.0D);
-                tessellator.addVertex(x,            y + 2 + fontHeight() - 1.0F, 0.0D);
+                tessellator.addVertex(x,             y + px2 + fontHeight,      0.0D);
+                tessellator.addVertex(x + px + shift,y + px2 + fontHeight,      0.0D);
+                tessellator.addVertex(x + px + shift,y + px2 + fontHeight - px, 0.0D);
+                tessellator.addVertex(x,             y + px2 + fontHeight - px, 0.0D);
             }
             tessellator.setColorRGBA_I(rgb, a);
-            tessellator.addVertex(x - 1,    y + 1 + fontHeight(),        0.0D);
-            tessellator.addVertex(x + shift,y + 1 + fontHeight(),        0.0D);
-            tessellator.addVertex(x + shift,y + 1 + fontHeight() - 1.0F, 0.0D);
-            tessellator.addVertex(x - 1,    y + 1 + fontHeight() - 1.0F, 0.0D);
+            tessellator.addVertex(x - px,    y + px + fontHeight,      0.0D);
+            tessellator.addVertex(x + shift, y + px + fontHeight,      0.0D);
+            tessellator.addVertex(x + shift, y + px + fontHeight - px, 0.0D);
+            tessellator.addVertex(x - px,    y + px + fontHeight - px, 0.0D);
             tessellator.draw();
             GL11.glEnable(GL11.GL_TEXTURE_2D);
         }
         return shift;
     }
     @Override
-    public void renderDouble(@NotNull final Tessellator tessellator, final @NotNull CharSequence chars, final double x, final double y, final double z, final boolean shadow, final long baseConfig, final double @Nullable [] xPosBuffer, final double @Nullable [] yPosBuffer, final long @Nullable [] configBuffer) {
+    public void renderDoubleImpl(@NotNull final Font font, @NotNull final Tessellator tessellator, final @NotNull CharSequence chars, final double x, final double y, final double z, final boolean shadow, final long baseConfig, final double @Nullable [] xPosBuffer, final double @Nullable [] yPosBuffer, final long @Nullable [] configBuffer) {
         this.currentTex = -1;
         this.currentConfig = baseConfig;
         this.stackIndex = 0;
-        renderStringInternal(tessellator, chars, x, y, z, shadow, baseConfig, xPosBuffer, yPosBuffer, configBuffer);
+        renderStringInternal(font, tessellator, chars, x, y, z, shadow, baseConfig, xPosBuffer, yPosBuffer, configBuffer);
     }
 
     @Override
-    public void render(@NotNull final Tessellator tessellator, final @NotNull CharSequence chars, final int x, final int y, final double z, final boolean shadow, final long baseConfig, final double @Nullable [] xPosBuffer, final double @Nullable [] yPosBuffer, final long @Nullable [] configBuffer) {
-        renderDouble(tessellator, chars, x, y, z, shadow, baseConfig, xPosBuffer, yPosBuffer, configBuffer);
+    public void renderImpl(@NotNull final Font font, @NotNull final Tessellator tessellator, final @NotNull CharSequence chars, final int x, final int y, final double z, final boolean shadow, final long baseConfig, final double @Nullable [] xPosBuffer, final double @Nullable [] yPosBuffer, final long @Nullable [] configBuffer) {
+        renderDoubleImpl(font, tessellator, chars, x, y, z, shadow, baseConfig, xPosBuffer, yPosBuffer, configBuffer);
     }
 
     @Override
-    public void renderCenteredDouble(@NotNull final Tessellator tessellator, final @NotNull CharSequence chars, final double x, final double y, final double z, final boolean shadow, final long baseConfig, final double @Nullable [] xPosBuffer, final double @Nullable [] yPosBuffer, final long @Nullable [] configBuffer) {
-        renderDouble(tessellator, chars, x - stringWidthDouble(chars)/2d, y, z, shadow, baseConfig, xPosBuffer, yPosBuffer, configBuffer);
+    public void renderCenteredDoubleImpl(@NotNull final Font font, @NotNull final Tessellator tessellator, final @NotNull CharSequence chars, final double x, final double y, final double z, final boolean shadow, final long baseConfig, final double @Nullable [] xPosBuffer, final double @Nullable [] yPosBuffer, final long @Nullable [] configBuffer) {
+        renderDoubleImpl(font, tessellator, chars, x - stringWidthDouble(chars)/2d, y, z, shadow, baseConfig, xPosBuffer, yPosBuffer, configBuffer);
     }
 
     @Override
-    public void renderCentered(@NotNull final Tessellator tessellator, final @NotNull CharSequence chars, final int x, final int y, final double z, final boolean shadow, final long baseConfig, final double @Nullable [] xPosBuffer, final double @Nullable [] yPosBuffer, final long @Nullable [] configBuffer) {
-        render(tessellator, chars, x - stringWidth(chars)/2, y, z, shadow, baseConfig, xPosBuffer, yPosBuffer, configBuffer);
+    public void renderCenteredImpl(@NotNull final Font font, @NotNull final Tessellator tessellator, final @NotNull CharSequence chars, final int x, final int y, final double z, final boolean shadow, final long baseConfig, final double @Nullable [] xPosBuffer, final double @Nullable [] yPosBuffer, final long @Nullable [] configBuffer) {
+        renderImpl(font, tessellator, chars, x - stringWidth(chars)/2, y, z, shadow, baseConfig, xPosBuffer, yPosBuffer, configBuffer);
     }
 
     @Override
-    public void renderWidthConstrainedDouble(@NotNull final Tessellator tessellator, @NotNull final CharSequence chars, final double x, final double y, final double z, final boolean shadow, final long baseConfig, final double maxWidth, @NotNull final Alignment alignment, final double @Nullable [] xPosBuffer, final double @Nullable [] yPosBuffer, final long @Nullable [] configBuffer) {
+    public void renderWidthConstrainedDoubleImpl(@NotNull final Font font, @NotNull final Tessellator tessellator, @NotNull final CharSequence chars, final double x, final double y, final double z, final boolean shadow, final long baseConfig, final double maxWidth, @NotNull final Alignment alignment, final double @Nullable [] xPosBuffer, final double @Nullable [] yPosBuffer, final long @Nullable [] configBuffer) {
         this.currentTex = -1;
         this.currentConfig = baseConfig;
         this.stackIndex = 0;
@@ -264,24 +272,24 @@ public class FontRendererDefault implements FontRenderer {
             case LEFT: {
                 for (int i = 0; i < lines.size(); i++) {
                     final String line = lines.get(i);
-                    renderStringInternal(tessellator, line, x, currY, z, shadow, baseConfig, this.localXPosBuffer, this.localYPosBuffer, this.localConfigBuffer);
-                    currY += fontHeight() + 1;
+                    renderStringInternal(font, tessellator, line, x, currY, z, shadow, baseConfig, this.localXPosBuffer, this.localYPosBuffer, this.localConfigBuffer);
+                    currY += font.fontHeight() + 1;
                 }
                 break;
             }
             case RIGHT: {
                 for (int i = 0; i < lines.size(); i++) {
                     final String line = lines.get(i);
-                    renderStringInternal(tessellator, line, x + (maxWidth - stringWidthDouble(line)), currY, z, shadow, baseConfig, this.localXPosBuffer, this.localYPosBuffer, this.localConfigBuffer);
-                    currY += fontHeight() + 1;
+                    renderStringInternal(font, tessellator, line, x + (maxWidth - stringWidthDouble(line)), currY, z, shadow, baseConfig, this.localXPosBuffer, this.localYPosBuffer, this.localConfigBuffer);
+                    currY += font.fontHeight() + 1;
                 }
                 break;
             }
             case CENTERED: {
                 for (int i = 0; i < lines.size(); i++) {
                     final String line = lines.get(i);
-                    renderStringInternal(tessellator, line, x + (maxWidth - stringWidthDouble(line))/2, currY, z, shadow, baseConfig, this.localXPosBuffer, this.localYPosBuffer, this.localConfigBuffer);
-                    currY += fontHeight() + 1;
+                    renderStringInternal(font, tessellator, line, x + (maxWidth - stringWidthDouble(line))/2, currY, z, shadow, baseConfig, this.localXPosBuffer, this.localYPosBuffer, this.localConfigBuffer);
+                    currY += font.fontHeight() + 1;
                 }
                 break;
             }
@@ -299,7 +307,7 @@ public class FontRendererDefault implements FontRenderer {
     }
 
     @Override
-    public void renderWidthConstrained(@NotNull final Tessellator tessellator, @NotNull final CharSequence chars, final int x, final int y, final double z, final boolean shadow, final long baseConfig, final int maxWidth, @NotNull final Alignment alignment, final double @Nullable [] xPosBuffer, final double @Nullable [] yPosBuffer, final long @Nullable [] configBuffer) {
+    public void renderWidthConstrainedImpl(@NotNull final Font font, @NotNull final Tessellator tessellator, @NotNull final CharSequence chars, final int x, final int y, final double z, final boolean shadow, final long baseConfig, final int maxWidth, @NotNull final Alignment alignment, final double @Nullable [] xPosBuffer, final double @Nullable [] yPosBuffer, final long @Nullable [] configBuffer) {
         this.currentTex = -1;
         this.currentConfig = baseConfig;
         this.stackIndex = 0;
@@ -311,24 +319,24 @@ public class FontRendererDefault implements FontRenderer {
             case LEFT: {
                 for (int i = 0; i < lines.size(); i++) {
                     final String line = lines.get(i);
-                    renderStringInternal(tessellator, line, x, currY, z, shadow, baseConfig, this.localXPosBuffer, this.localYPosBuffer, this.localConfigBuffer);
-                    currY += fontHeight() + 1;
+                    renderStringInternal(font, tessellator, line, x, currY, z, shadow, baseConfig, this.localXPosBuffer, this.localYPosBuffer, this.localConfigBuffer);
+                    currY += font.fontHeight() + 1;
                 }
                 break;
             }
             case RIGHT: {
                 for (int i = 0; i < lines.size(); i++) {
                     final String line = lines.get(i);
-                    renderStringInternal(tessellator, line, x + (maxWidth - stringWidth(line)), currY, z, shadow, baseConfig, this.localXPosBuffer, this.localYPosBuffer, this.localConfigBuffer);
-                    currY += fontHeight() + 1;
+                    renderStringInternal(font, tessellator, line, x + (maxWidth - stringWidth(line)), currY, z, shadow, baseConfig, this.localXPosBuffer, this.localYPosBuffer, this.localConfigBuffer);
+                    currY += font.fontHeight() + 1;
                 }
                 break;
             }
             case CENTERED: {
                 for (int i = 0; i < lines.size(); i++) {
                     final String line = lines.get(i);
-                    renderStringInternal(tessellator, line, (int)(x + (maxWidth - stringWidth(line))/2), currY, z, shadow, baseConfig, this.localXPosBuffer, this.localYPosBuffer, this.localConfigBuffer);
-                    currY += fontHeight() + 1;
+                    renderStringInternal(font, tessellator, line, (int)(x + (maxWidth - stringWidth(line))/2), currY, z, shadow, baseConfig, this.localXPosBuffer, this.localYPosBuffer, this.localConfigBuffer);
+                    currY += font.fontHeight() + 1;
                 }
                 break;
             }
@@ -346,7 +354,7 @@ public class FontRendererDefault implements FontRenderer {
     }
 
     @Override
-    public void renderConstrainedDouble(@NotNull final Tessellator tessellator, @NotNull final CharSequence chars, final double x, final double y, final double z, final boolean shadow, final long baseConfig, final double maxWidth, final double maxHeight, @NotNull final Alignment alignment, final double @Nullable [] xPosBuffer, final double @Nullable [] yPosBuffer, final long @Nullable [] configBuffer) {
+    public void renderConstrainedDoubleImpl(@NotNull final Font font, @NotNull final Tessellator tessellator, @NotNull final CharSequence chars, final double x, final double y, final double z, final boolean shadow, final long baseConfig, final double maxWidth, final double maxHeight, @NotNull final Alignment alignment, final double @Nullable [] xPosBuffer, final double @Nullable [] yPosBuffer, final long @Nullable [] configBuffer) {
         this.currentTex = -1;
         this.currentConfig = baseConfig;
         this.stackIndex = 0;
@@ -359,8 +367,8 @@ public class FontRendererDefault implements FontRenderer {
             case LEFT: {
                 for (int i = 0; i < lines.size(); i++) {
                     final String line = lines.get(i);
-                    renderStringInternal(tessellator, line, x, currY, z, shadow, baseConfig, null, null, this.localConfigBuffer);
-                    currY += fontHeight() + 1;
+                    renderStringInternal(font, tessellator, line, x, currY, z, shadow, baseConfig, null, null, this.localConfigBuffer);
+                    currY += font.fontHeight() + 1;
                     if ((currY - y) > maxHeight) break;
                 }
                 break;
@@ -368,8 +376,8 @@ public class FontRendererDefault implements FontRenderer {
             case RIGHT: {
                 for (int i = 0; i < lines.size(); i++) {
                     final String line = lines.get(i);
-                    renderStringInternal(tessellator, line, x + (maxWidth - stringWidthDouble(line)), currY, z, shadow, baseConfig, null, null, this.localConfigBuffer);
-                    currY += fontHeight() + 1;
+                    renderStringInternal(font, tessellator, line, x + (maxWidth - stringWidthDouble(line)), currY, z, shadow, baseConfig, null, null, this.localConfigBuffer);
+                    currY += font.fontHeight() + 1;
                     if ((currY - y) > maxHeight) break;
                 }
                 break;
@@ -377,8 +385,8 @@ public class FontRendererDefault implements FontRenderer {
             case CENTERED: {
                 for (int i = 0; i < lines.size(); i++) {
                     final String line = lines.get(i);
-                    renderCenteredDouble(tessellator, line, x + maxWidth/2, currY, z, shadow, baseConfig, null, null, this.localConfigBuffer);
-                    currY += fontHeight() + 1;
+                    renderCenteredDoubleImpl(font, tessellator, line, x + maxWidth/2, currY, z, shadow, baseConfig, null, null, this.localConfigBuffer);
+                    currY += font.fontHeight() + 1;
                     if ((currY - y) > maxHeight) break;
                 }
                 break;
@@ -397,15 +405,15 @@ public class FontRendererDefault implements FontRenderer {
     }
 
     @Override
-    public void renderConstrained(@NotNull final Tessellator tessellator, @NotNull final CharSequence chars, final int x, final int y, final double z, final boolean shadow, final long baseConfig, final int maxWidth, final int maxHeight, @NotNull final Alignment alignment, final double @Nullable [] xPosBuffer, final double @Nullable [] yPosBuffer, final long @Nullable [] configBuffer) {
-        renderConstrainedDouble(tessellator, chars, x, y, z, shadow, baseConfig, maxWidth, maxHeight, alignment, xPosBuffer, yPosBuffer, configBuffer);
+    public void renderConstrainedImpl(@NotNull final Font font, @NotNull final Tessellator tessellator, @NotNull final CharSequence chars, final int x, final int y, final double z, final boolean shadow, final long baseConfig, final int maxWidth, final int maxHeight, @NotNull final Alignment alignment, final double @Nullable [] xPosBuffer, final double @Nullable [] yPosBuffer, final long @Nullable [] configBuffer) {
+        renderConstrainedDoubleImpl(font, tessellator, chars, x, y, z, shadow, baseConfig, maxWidth, maxHeight, alignment, xPosBuffer, yPosBuffer, configBuffer);
     }
 
     private static final StringBuilder splitLineIntoConstrainedLine_lineBuilder = new StringBuilder();
     private static final StringBuilder splitLineIntoConstrainedLine_wordBuilder = new StringBuilder();
-    protected void splitLineIntoConstrainedLine(final @NotNull CharSequence line, final double maxWidth, final @NotNull List<String> output) {
-        final double dashWidth = charWidthDouble('-');
-        final double spaceWidth = charWidthDouble(' ');
+    protected void splitLineIntoConstrainedLine(final @NotNull Font font, final @NotNull CharSequence line, final double maxWidth, final @NotNull List<String> output) {
+        final double dashWidth = font.charWidthDouble('-');
+        final double spaceWidth = font.charWidthDouble(' ');
 
         double currLineWidth = 0;
         double currWordWidth = 0;
@@ -438,15 +446,13 @@ public class FontRendererDefault implements FontRenderer {
                 final char cN = line.charAt(i + 1);
                 if (cN == '<') {
                     int offAmount = 1;
-                    int j = i + 2; // first char after '<'
                     boolean ended = false;
-                    while (j < length) {
+                    for (int j = 0; j < 8; j++) { // Maximum of 8 chars allowed in argb color code
                         offAmount++;
-                        if (line.charAt(j) == '>'){
+                        if (line.charAt(j + i + 2) == '>'){
                             ended = true;
                             break;
                         }
-                        j++;
                     }
 
                     if (ended){
@@ -465,7 +471,7 @@ public class FontRendererDefault implements FontRenderer {
                 }
             }
 
-            final double charWidth = charWidthDouble(c);
+            final double charWidth = font.canRenderChar(c) ? font.charWidthDouble(c) : this.fallbackFont.charWidthDouble(c);
             if (currWordWidth + charWidth + dashWidth > maxWidth) {
                 splitLineIntoConstrainedLine_wordBuilder.append('-');
                 splitLineIntoConstrainedLine_lineBuilder.append(splitLineIntoConstrainedLine_wordBuilder);
